diff --git a/compiler/simplCore/SetLevels.lhs b/compiler/simplCore/SetLevels.lhs
index 2fca56c..eb5e0fe 100644
--- a/compiler/simplCore/SetLevels.lhs
+++ b/compiler/simplCore/SetLevels.lhs
@@ -3,9 +3,9 @@
 %
 \section{SetLevels}
 
-		***************************
-			Overview
-		***************************
+                ***************************
+                        Overview
+                ***************************
 
 1. We attach binding levels to Core bindings, in preparation for floating
    outwards (@FloatOut@).
@@ -19,20 +19,20 @@
    that may not be true.)
 
    NOTE: this can't be done using the uniqAway idea, because the variable
- 	 must be unique in the whole program, not just its current scope,
-	 because two variables in different scopes may float out to the
-	 same top level place
+         must be unique in the whole program, not just its current scope,
+         because two variables in different scopes may float out to the
+         same top level place
 
    NOTE: Very tiresomely, we must apply this substitution to
-	 the rules stored inside a variable too.
+         the rules stored inside a variable too.
 
    We do *not* clone top-level bindings, because some of them must not change,
    but we *do* clone bindings that are heading for the top level
 
 4. In the expression
-	case x of wild { p -> ...wild... }
+        case x of wild { p -> ...wild... }
    we substitute x for wild in the RHS of the case alternatives:
-	case x of wild { p -> ...x... }
+        case x of wild { p -> ...x... }
    This means that a sub-expression involving x is not "trapped" inside the RHS.
    And it's not inconvenient because we already have a substitution.
 
@@ -42,33 +42,27 @@
   the scrutinee of the case, and we can inline it.  
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module SetLevels (
-	setLevels, 
+        setLevels, 
 
-	Level(..), tOP_LEVEL,
-	LevelledBind, LevelledExpr, LevelledBndr,
-	FloatSpec(..), floatSpecLevel,
+        Level(..), tOP_LEVEL,
+        LevelledBind, LevelledExpr, LevelledBndr,
+        FloatSpec(..), floatSpecLevel,
 
-	incMinorLvl, ltMajLvl, ltLvl, isTopLvl
+        incMinorLvl, ltMajLvl, ltLvl, isTopLvl
     ) where
 
 #include "HsVersions.h"
 
 import CoreSyn
-import CoreMonad	( FloatOutSwitches(..) )
-import CoreUtils	( exprType, exprOkForSpeculation )
-import CoreArity	( exprBotStrictness_maybe )
-import CoreFVs		-- all of it
+import CoreMonad        ( FloatOutSwitches(..) )
+import CoreUtils        ( exprType, exprOkForSpeculation )
+import CoreArity        ( exprBotStrictness_maybe )
+import CoreFVs          -- all of it
 import Coercion         ( isCoVar )
-import CoreSubst	( Subst, emptySubst, extendInScope, substBndr, substRecBndrs,
-			  extendIdSubst, extendSubstWithVar, cloneBndr, 
+import CoreSubst        ( Subst, emptySubst, extendInScope, substBndr, substRecBndrs,
+                          extendIdSubst, extendSubstWithVar, cloneBndr, 
                           cloneRecIdBndrs, substTy, substCo )
 import MkCore           ( sortQuantVars ) 
 import Id
@@ -76,12 +70,12 @@ import IdInfo
 import Var
 import VarSet
 import VarEnv
-import Literal		( litIsTrivial )
+import Literal          ( litIsTrivial )
 import Demand           ( StrictSig, increaseStrictSigArity )
-import Name		( getOccName, mkSystemVarName )
-import OccName		( occNameString )
-import Type		( isUnLiftedType, Type, mkPiTypes )
-import BasicTypes	( Arity )
+import Name             ( getOccName, mkSystemVarName )
+import OccName          ( occNameString )
+import Type             ( isUnLiftedType, Type, mkPiTypes )
+import BasicTypes       ( Arity )
 import UniqSupply
 import Util
 import MonadUtils
@@ -90,9 +84,9 @@ import FastString
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Level numbers}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -100,16 +94,16 @@ type LevelledExpr = TaggedExpr FloatSpec
 type LevelledBind = TaggedBind FloatSpec
 type LevelledBndr = TaggedBndr FloatSpec
 
-data Level = Level Int	-- Major level: number of enclosing value lambdas
-	  	   Int	-- Minor level: number of big-lambda and/or case 
+data Level = Level Int  -- Major level: number of enclosing value lambdas
+                   Int  -- Minor level: number of big-lambda and/or case 
                         -- expressions between here and the nearest 
                         -- enclosing value lambda
 
 data FloatSpec 
-  = FloatMe Level	-- Float to just inside the binding 
-    	    		--    tagged with this level
-  | StayPut Level	-- Stay where it is; binding is
-    	    		--     tagged with tihs level
+  = FloatMe Level       -- Float to just inside the binding 
+                        --    tagged with this level
+  | StayPut Level       -- Stay where it is; binding is
+                        --     tagged with tihs level
 
 floatSpecLevel :: FloatSpec -> Level
 floatSpecLevel (FloatMe l) = l
@@ -129,7 +123,7 @@ definition but ``before'' a lambda; e.g., the \tr{x} in (levels shown
 as ``subscripts'')...
 \begin{verbatim}
 a_0 = let  b_? = ...  in
-	   x_1 = ... b ... in ...
+           x_1 = ... b ... in ...
 \end{verbatim}
 
 The main function @lvlExpr@ carries a ``context level'' (@ctxt_lvl@).
@@ -154,9 +148,9 @@ But, check this out:
 
 -- At one time I tried the effect of not float anything out of an InlineMe,
 -- but it sometimes works badly.  For example, consider PrelArr.done.  It
--- has the form 	__inline (\d. e)
+-- has the form         __inline (\d. e)
 -- where e doesn't mention d.  If we float this to 
---	__inline (let x = e in \d. x)
+--      __inline (let x = e in \d. x)
 -- things are bad.  The inliner doesn't even inline it because it doesn't look
 -- like a head-normal form.  So it seems a lesser evil to let things float.
 -- In SetLevels we do set the context to (Level 0 0) when we get to an InlineMe
@@ -187,7 +181,7 @@ incMinorLvl (Level major minor) = Level major (minor+1)
 maxLvl :: Level -> Level -> Level
 maxLvl l1@(Level maj1 min1) l2@(Level maj2 min2)
   | (maj1 > maj2) || (maj1 == maj2 && min1 > min2) = l1
-  | otherwise					   = l2
+  | otherwise                                      = l2
 
 ltLvl :: Level -> Level -> Bool
 ltLvl (Level maj1 min1) (Level maj2 min2)
@@ -210,16 +204,16 @@ instance Eq Level where
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Main level-setting code}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 setLevels :: FloatOutSwitches
-	  -> CoreProgram
-	  -> UniqSupply
-	  -> [LevelledBind]
+          -> CoreProgram
+          -> UniqSupply
+          -> [LevelledBind]
 
 setLevels float_lams binds us
   = initLvl us (do_them init_env binds)
@@ -249,24 +243,24 @@ lvlTopBind env (Rec pairs)
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Setting expression levels}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
-lvlExpr :: Level		-- ctxt_lvl: Level of enclosing expression
-	-> LevelEnv		-- Level of in-scope names/tyvars
-	-> CoreExprWithFVs	-- input expression
-	-> LvlM LevelledExpr	-- Result expression
+lvlExpr :: Level                -- ctxt_lvl: Level of enclosing expression
+        -> LevelEnv             -- Level of in-scope names/tyvars
+        -> CoreExprWithFVs      -- input expression
+        -> LvlM LevelledExpr    -- Result expression
 \end{code}
 
 The @ctxt_lvl@ is, roughly, the level of the innermost enclosing
 binder.  Here's an example
 
-	v = \x -> ...\y -> let r = case (..x..) of
-					..x..
-			   in ..
+        v = \x -> ...\y -> let r = case (..x..) of
+                                        ..x..
+                           in ..
 
 When looking at the rhs of @r@, @ctxt_lvl@ will be 1 because that's
 the level of @r@, even though it's inside a level-2 @\y@.  It's
@@ -328,9 +322,9 @@ lvlExpr ctxt_lvl env (_, AnnCast expr (_, co)) = do
     return (Cast expr' (substCo (le_subst env) co))
 
 -- We don't split adjacent lambdas.  That is, given
---	\x y -> (x+1,y)
+--      \x y -> (x+1,y)
 -- we don't float to give 
---	\x -> let v = x+y in \y -> (v,y)
+--      \x -> let v = x+y in \y -> (v,y)
 -- Why not?  Because partial applications are fairly rare, and splitting
 -- lambdas makes them more expensive.
 
@@ -338,15 +332,15 @@ lvlExpr ctxt_lvl env expr@(_, AnnLam {}) = do
     new_body <- lvlMFE True new_lvl new_env body
     return (mkLams new_bndrs new_body)
   where 
-    (bndrs, body)	 = collectAnnBndrs expr
+    (bndrs, body)        = collectAnnBndrs expr
     (new_lvl, new_bndrs) = lvlLamBndrs ctxt_lvl bndrs
-    new_env 		 = extendLvlEnv env new_bndrs
-	-- At one time we called a special verion of collectBinders,
-	-- which ignored coercions, because we don't want to split
-	-- a lambda like this (\x -> coerce t (\s -> ...))
-	-- This used to happen quite a bit in state-transformer programs,
-	-- but not nearly so much now non-recursive newtypes are transparent.
-	-- [See SetLevels rev 1.50 for a version with this approach.]
+    new_env              = extendLvlEnv env new_bndrs
+        -- At one time we called a special verion of collectBinders,
+        -- which ignored coercions, because we don't want to split
+        -- a lambda like this (\x -> coerce t (\s -> ...))
+        -- This used to happen quite a bit in state-transformer programs,
+        -- but not nearly so much now non-recursive newtypes are transparent.
+        -- [See SetLevels rev 1.50 for a version with this approach.]
 
 lvlExpr ctxt_lvl env (_, AnnLet bind body) = do
     (bind', new_lvl, new_env) <- lvlBind ctxt_lvl env bind
@@ -358,29 +352,29 @@ lvlExpr ctxt_lvl env (_, AnnCase scrut@(scrut_fvs,_) case_bndr ty alts)
        ; lvlCase ctxt_lvl env scrut_fvs scrut' case_bndr ty alts }
 
 -------------------------------------------
-lvlCase :: Level		-- ctxt_lvl: Level of enclosing expression
-	-> LevelEnv		-- Level of in-scope names/tyvars
-        -> VarSet		-- Free vars of input scrutinee
-        -> LevelledExpr		-- Processed scrutinee
-	-> Id -> Type		-- Case binder and result type
-	-> [AnnAlt Id VarSet]	-- Input alternatives
-	-> LvlM LevelledExpr	-- Result expression
+lvlCase :: Level                -- ctxt_lvl: Level of enclosing expression
+        -> LevelEnv             -- Level of in-scope names/tyvars
+        -> VarSet               -- Free vars of input scrutinee
+        -> LevelledExpr         -- Processed scrutinee
+        -> Id -> Type           -- Case binder and result type
+        -> [AnnAlt Id VarSet]   -- Input alternatives
+        -> LvlM LevelledExpr    -- Result expression
 lvlCase ctxt_lvl env scrut_fvs scrut' case_bndr ty alts
   | [(con@(DataAlt {}), bs, rhs)] <- alts
-  , exprOkForSpeculation scrut'	  -- See Note [Check the output scrutinee for okForSpec]
-  , not (isTopLvl dest_lvl)	  -- Can't have top-level cases
+  , exprOkForSpeculation scrut'   -- See Note [Check the output scrutinee for okForSpec]
+  , not (isTopLvl dest_lvl)       -- Can't have top-level cases
   =     -- See Note [Floating cases]
-    	-- Always float the case if possible
-  	-- Unlike lets we don't insist that it escapes a value lambda
+        -- Always float the case if possible
+        -- Unlike lets we don't insist that it escapes a value lambda
     do { (rhs_env, (case_bndr':bs')) <- cloneVars env (case_bndr:bs) dest_lvl
-       	 	   -- We don't need to use extendCaseBndrLvlEnv here
-		   -- because we are floating the case outwards so
-		   -- no need to do the binder-swap thing
+                   -- We don't need to use extendCaseBndrLvlEnv here
+                   -- because we are floating the case outwards so
+                   -- no need to do the binder-swap thing
        ; rhs' <- lvlMFE True ctxt_lvl rhs_env rhs
        ; let alt' = (con, [TB b (StayPut dest_lvl) | b <- bs'], rhs')
        ; return (Case scrut' (TB case_bndr' (FloatMe dest_lvl)) ty [alt']) }
 
-  | otherwise	  -- Stays put
+  | otherwise     -- Stays put
   = do { let case_bndr' = TB case_bndr bndr_spec
              alts_env   = extendCaseBndrLvlEnv env scrut' case_bndr'
        ; alts' <- mapM (lvl_alt alts_env) alts
@@ -389,7 +383,7 @@ lvlCase ctxt_lvl env scrut_fvs scrut' case_bndr ty alts
       incd_lvl  = incMinorLvl ctxt_lvl
       bndr_spec = StayPut incd_lvl
       dest_lvl = maxFvLevel (const True) env scrut_fvs
-   	      -- Don't abstact over type variables, hence const True
+              -- Don't abstact over type variables, hence const True
 
       lvl_alt alts_env (con, bs, rhs)
         = do { rhs' <- lvlMFE True incd_lvl new_env rhs
@@ -444,11 +438,11 @@ binding site.
 That's why we apply exprOkForSpeculation to scrut' and not to scrut.
 
 \begin{code}
-lvlMFE ::  Bool			-- True <=> strict context [body of case or let]
-	-> Level		-- Level of innermost enclosing lambda/tylam
-	-> LevelEnv		-- Level of in-scope names/tyvars
-	-> CoreExprWithFVs	-- input expression
-	-> LvlM LevelledExpr	-- Result expression
+lvlMFE ::  Bool                 -- True <=> strict context [body of case or let]
+        -> Level                -- Level of innermost enclosing lambda/tylam
+        -> LevelEnv             -- Level of in-scope names/tyvars
+        -> CoreExprWithFVs      -- input expression
+        -> LvlM LevelledExpr    -- Result expression
 -- lvlMFE is just like lvlExpr, except that it might let-bind
 -- the expression, so that it can itself be floated.
 
@@ -457,30 +451,30 @@ lvlMFE _ _ env (_, AnnType ty)
 
 -- No point in floating out an expression wrapped in a coercion or note
 -- If we do we'll transform  lvl = e |> co 
---			 to  lvl' = e; lvl = lvl' |> co
+--                       to  lvl' = e; lvl = lvl' |> co
 -- and then inline lvl.  Better just to float out the payload.
 lvlMFE strict_ctxt ctxt_lvl env (_, AnnTick t e)
   = do { e' <- lvlMFE strict_ctxt ctxt_lvl env e
        ; return (Tick t e') }
 
 lvlMFE strict_ctxt ctxt_lvl env (_, AnnCast e (_, co))
-  = do	{ e' <- lvlMFE strict_ctxt ctxt_lvl env e
-	; return (Cast e' (substCo (le_subst env) co)) }
+  = do  { e' <- lvlMFE strict_ctxt ctxt_lvl env e
+        ; return (Cast e' (substCo (le_subst env) co)) }
 
 -- Note [Case MFEs]
 lvlMFE True ctxt_lvl env e@(_, AnnCase {})
   = lvlExpr ctxt_lvl env e     -- Don't share cases
 
 lvlMFE strict_ctxt ctxt_lvl env ann_expr@(fvs, _)
-  |  isUnLiftedType ty		-- Can't let-bind it; see Note [Unlifted MFEs]
-     		    		-- This includes coercions, which we don't
-				-- want to float anyway
+  |  isUnLiftedType ty          -- Can't let-bind it; see Note [Unlifted MFEs]
+                                -- This includes coercions, which we don't
+                                -- want to float anyway
   || notWorthFloating ann_expr abs_vars
   || not float_me
-  = 	-- Don't float it out
+  =     -- Don't float it out
     lvlExpr ctxt_lvl env ann_expr
 
-  | otherwise	-- Float it out!
+  | otherwise   -- Float it out!
   = do expr' <- lvlFloatRhs abs_vars dest_lvl env ann_expr
        var <- newLvlVar abs_vars ty mb_bot
        return (Let (NonRec (TB var (FloatMe dest_lvl)) expr') 
@@ -492,53 +486,53 @@ lvlMFE strict_ctxt ctxt_lvl env ann_expr@(fvs, _)
     dest_lvl = destLevel env fvs (isFunction ann_expr) mb_bot
     abs_vars = abstractVars dest_lvl env fvs
 
-	-- A decision to float entails let-binding this thing, and we only do 
-	-- that if we'll escape a value lambda, or will go to the top level.
-    float_me = dest_lvl `ltMajLvl` ctxt_lvl		-- Escapes a value lambda
-    	     	-- OLD CODE: not (exprIsCheap expr) || isTopLvl dest_lvl
-		-- 	     see Note [Escaping a value lambda]
-
-            || (isTopLvl dest_lvl 	-- Only float if we are going to the top level
-         	&& floatConsts env	--   and the floatConsts flag is on
-              	&& not strict_ctxt)	-- Don't float from a strict context	
-	  -- We are keen to float something to the top level, even if it does not
-	  -- escape a lambda, because then it needs no allocation.  But it's controlled
-	  -- by a flag, because doing this too early loses opportunities for RULES
-	  -- which (needless to say) are important in some nofib programs
-	  -- (gcd is an example).
-	  --
-	  -- Beware:
-	  --	concat = /\ a -> foldr ..a.. (++) []
-	  -- was getting turned into
-	  --	lvl    = /\ a -> foldr ..a.. (++) []
-	  --	concat = /\ a -> lvl a
-	  -- which is pretty stupid.  Hence the strict_ctxt test
-	  -- 
-	  -- Also a strict contxt includes uboxed values, and they
-	  -- can't be bound at top level
+        -- A decision to float entails let-binding this thing, and we only do 
+        -- that if we'll escape a value lambda, or will go to the top level.
+    float_me = dest_lvl `ltMajLvl` ctxt_lvl             -- Escapes a value lambda
+                -- OLD CODE: not (exprIsCheap expr) || isTopLvl dest_lvl
+                --           see Note [Escaping a value lambda]
+
+            || (isTopLvl dest_lvl       -- Only float if we are going to the top level
+                && floatConsts env      --   and the floatConsts flag is on
+                && not strict_ctxt)     -- Don't float from a strict context    
+          -- We are keen to float something to the top level, even if it does not
+          -- escape a lambda, because then it needs no allocation.  But it's controlled
+          -- by a flag, because doing this too early loses opportunities for RULES
+          -- which (needless to say) are important in some nofib programs
+          -- (gcd is an example).
+          --
+          -- Beware:
+          --    concat = /\ a -> foldr ..a.. (++) []
+          -- was getting turned into
+          --    lvl    = /\ a -> foldr ..a.. (++) []
+          --    concat = /\ a -> lvl a
+          -- which is pretty stupid.  Hence the strict_ctxt test
+          -- 
+          -- Also a strict contxt includes uboxed values, and they
+          -- can't be bound at top level
 \end{code}
 
 Note [Unlifted MFEs]
 ~~~~~~~~~~~~~~~~~~~~
 We don't float unlifted MFEs, which potentially loses big opportunites.
 For example:
-	\x -> f (h y)
+        \x -> f (h y)
 where h :: Int -> Int# is expensive. We'd like to float the (h y) outside
 the \x, but we don't because it's unboxed.  Possible solution: box it.
 
 Note [Bottoming floats]
 ~~~~~~~~~~~~~~~~~~~~~~~
 If we see
-	f = \x. g (error "urk")
+        f = \x. g (error "urk")
 we'd like to float the call to error, to get
-	lvl = error "urk"
-	f = \x. g lvl
+        lvl = error "urk"
+        f = \x. g lvl
 Furthermore, we want to float a bottoming expression even if it has free
 variables:
-	f = \x. g (let v = h x in error ("urk" ++ v))
+        f = \x. g (let v = h x in error ("urk" ++ v))
 Then we'd like to abstact over 'x' can float the whole arg of g:
-	lvl = \x. let v = h x in error ("urk" ++ v)
-	f = \x. g (lvl x)
+        lvl = \x. let v = h x in error ("urk" ++ v)
+        f = \x. g (lvl x)
 See Maessen's paper 1999 "Bottom extraction: factoring error handling out
 of functional programs" (unpublished I think).
 
@@ -565,7 +559,7 @@ Doesn't change any other allocation at all.
 annotateBotStr :: Id -> Maybe (Arity, StrictSig) -> Id
 annotateBotStr id Nothing            = id
 annotateBotStr id (Just (arity, sig)) = id `setIdArity` arity
-     		                              `setIdStrictness` sig
+                                              `setIdStrictness` sig
 
 notWorthFloating :: CoreExprWithFVs -> [Var] -> Bool
 -- Returns True if the expression would be replaced by
@@ -573,7 +567,7 @@ notWorthFloating :: CoreExprWithFVs -> [Var] -> Bool
 --   abs_vars = tvars only:  return True if e is trivial, 
 --                           but False for anything bigger
 --   abs_vars = [x] (an Id): return True for trivial, or an application (f x)
---   	      	    	     but False for (f x x)
+--                           but False for (f x x)
 --
 -- One big goal is that floating should be idempotent.  Eg if
 -- we replace e with (lvl79 x y) and then run FloatOut again, don't want
@@ -584,19 +578,19 @@ notWorthFloating e abs_vars
   where
     go (_, AnnVar {}) n    = n >= 0
     go (_, AnnLit lit) n   = ASSERT( n==0 ) 
-                             litIsTrivial lit	-- Note [Floating literals]
+                             litIsTrivial lit   -- Note [Floating literals]
     go (_, AnnCast e _)  n = go e n
     go (_, AnnApp e arg) n 
        | (_, AnnType {}) <- arg = go e n
        | (_, AnnCoercion {}) <- arg = go e n
        | n==0                   = False
-       | is_triv arg       	= go e (n-1)
-       | otherwise         	= False
-    go _ _                 	= False
+       | is_triv arg            = go e (n-1)
+       | otherwise              = False
+    go _ _                      = False
 
-    is_triv (_, AnnLit {})   	       	  = True	-- Treat all literals as trivial
-    is_triv (_, AnnVar {})   	       	  = True	-- (ie not worth floating)
-    is_triv (_, AnnCast e _) 	       	  = is_triv e
+    is_triv (_, AnnLit {})                = True        -- Treat all literals as trivial
+    is_triv (_, AnnVar {})                = True        -- (ie not worth floating)
+    is_triv (_, AnnCast e _)              = is_triv e
     is_triv (_, AnnApp e (_, AnnType {})) = is_triv e
     is_triv (_, AnnApp e (_, AnnCoercion {})) = is_triv e
     is_triv _                             = False     
@@ -616,7 +610,7 @@ Note [Escaping a value lambda]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 We want to float even cheap expressions out of value lambdas, 
 because that saves allocation.  Consider
-	f = \x.  .. (\y.e) ...
+        f = \x.  .. (\y.e) ...
 Then we'd like to avoid allocating the (\y.e) every time we call f,
 (assuming e does not mention x).   
 
@@ -624,10 +618,10 @@ An example where this really makes a difference is simplrun009.
 
 Another reason it's good is because it makes SpecContr fire on functions.
 Consider
-	f = \x. ....(f (\y.e))....
+        f = \x. ....(f (\y.e))....
 After floating we get
-	lvl = \y.e
-	f = \x. ....(f lvl)...
+        lvl = \y.e
+        f = \x. ....(f lvl)...
 and that is much easier for SpecConstr to generate a robust specialisation for.
 
 The OLD CODE (given where this Note is referred to) prevents floating
@@ -639,47 +633,47 @@ zeros everywhere, but a 4% win for 'puzzle'.  Very small 0.5% loss for
 yet (mentioned in Simon-nofib-notes).
 
 OLD comment was:
-	 Even if it escapes a value lambda, we only
-	 float if it's not cheap (unless it'll get all the
-	 way to the top).  I've seen cases where we
-	 float dozens of tiny free expressions, which cost
-	 more to allocate than to evaluate.
-	 NB: exprIsCheap is also true of bottom expressions, which
-	     is good; we don't want to share them
-
-	It's only Really Bad to float a cheap expression out of a
-	strict context, because that builds a thunk that otherwise
-	would never be built.  So another alternative would be to
-	add 
-		|| (strict_ctxt && not (exprIsBottom expr))
-	to the condition above. We should really try this out.
+         Even if it escapes a value lambda, we only
+         float if it's not cheap (unless it'll get all the
+         way to the top).  I've seen cases where we
+         float dozens of tiny free expressions, which cost
+         more to allocate than to evaluate.
+         NB: exprIsCheap is also true of bottom expressions, which
+             is good; we don't want to share them
+
+        It's only Really Bad to float a cheap expression out of a
+        strict context, because that builds a thunk that otherwise
+        would never be built.  So another alternative would be to
+        add 
+                || (strict_ctxt && not (exprIsBottom expr))
+        to the condition above. We should really try this out.
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Bindings}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 The binding stuff works for top level too.
 
 \begin{code}
-lvlBind :: Level		-- Context level; might be Top even for bindings 
-				-- nested in the RHS of a top level binding
-	-> LevelEnv
-	-> CoreBindWithFVs
-	-> LvlM (LevelledBind, Level, LevelEnv)
+lvlBind :: Level                -- Context level; might be Top even for bindings 
+                                -- nested in the RHS of a top level binding
+        -> LevelEnv
+        -> CoreBindWithFVs
+        -> LvlM (LevelledBind, Level, LevelEnv)
 
 lvlBind ctxt_lvl env (AnnNonRec bndr rhs@(rhs_fvs,_))
   | isTyVar bndr    -- Don't do anything for TyVar binders
-	            --   (simplifier gets rid of them pronto)
+                    --   (simplifier gets rid of them pronto)
   || isCoVar bndr   -- Difficult to fix up CoVar occurrences (see extendPolyLvlEnv)
                     -- so we will ignore this case for now
   || not (profitableFloat ctxt_lvl dest_lvl)
   || (isTopLvl dest_lvl && isUnLiftedType (idType bndr))
-	  -- We can't float an unlifted binding to top level, so we don't 
-	  -- float it at all.  It's a bit brutal, but unlifted bindings 
-	  -- aren't expensive either
+          -- We can't float an unlifted binding to top level, so we don't 
+          -- float it at all.  It's a bit brutal, but unlifted bindings 
+          -- aren't expensive either
   = -- No float
     do rhs' <- lvlExpr ctxt_lvl env rhs
        let  (env', bndr') = substLetBndrNonRec env bndr bind_lvl
@@ -725,16 +719,16 @@ lvlBind ctxt_lvl env (AnnRec pairs)
 -- ToDo: when enabling the floatLambda stuff,
 --       I think we want to stop doing this
   | isSingleton pairs && count isId abs_vars > 1
-  = do	-- Special case for self recursion where there are
-	-- several variables carried around: build a local loop:	
-	--	poly_f = \abs_vars. \lam_vars . letrec f = \lam_vars. rhs in f lam_vars
-	-- This just makes the closures a bit smaller.  If we don't do
-	-- this, allocation rises significantly on some programs
-	--
-	-- We could elaborate it for the case where there are several
-	-- mutually functions, but it's quite a bit more complicated
-	-- 
-	-- This all seems a bit ad hoc -- sigh
+  = do  -- Special case for self recursion where there are
+        -- several variables carried around: build a local loop:        
+        --      poly_f = \abs_vars. \lam_vars . letrec f = \lam_vars. rhs in f lam_vars
+        -- This just makes the closures a bit smaller.  If we don't do
+        -- this, allocation rises significantly on some programs
+        --
+        -- We could elaborate it for the case where there are several
+        -- mutually functions, but it's quite a bit more complicated
+        -- 
+        -- This all seems a bit ad hoc -- sigh
     let
         (bndr,rhs) = head pairs
         (rhs_lvl, abs_vars_w_lvls) = lvlLamBndrs dest_lvl abs_vars
@@ -747,11 +741,11 @@ lvlBind ctxt_lvl env (AnnRec pairs)
     new_rhs_body <- lvlExpr body_lvl body_env rhs_body
     (poly_env, [poly_bndr]) <- newPolyBndrs dest_lvl env abs_vars [bndr]
     return (Rec [(TB poly_bndr (FloatMe dest_lvl) 
-               	 , mkLams abs_vars_w_lvls $
-               	   mkLams new_lam_bndrs $
-               	   Let (Rec [( TB new_bndr (StayPut rhs_lvl)
-               	             , mkLams new_lam_bndrs new_rhs_body)]) 
-               	       (mkVarApps (Var new_bndr) lam_bndrs))]
+                 , mkLams abs_vars_w_lvls $
+                   mkLams new_lam_bndrs $
+                   Let (Rec [( TB new_bndr (StayPut rhs_lvl)
+                             , mkLams new_lam_bndrs new_rhs_body)]) 
+                       (mkVarApps (Var new_bndr) lam_bndrs))]
            , ctxt_lvl
            , poly_env)
 
@@ -764,19 +758,19 @@ lvlBind ctxt_lvl env (AnnRec pairs)
   where
     (bndrs,rhss) = unzip pairs
 
-	-- Finding the free vars of the binding group is annoying
+        -- Finding the free vars of the binding group is annoying
     bind_fvs = (unionVarSets [ idFreeVars bndr `unionVarSet` rhs_fvs
-	     		    | (bndr, (rhs_fvs,_)) <- pairs])
-	       `minusVarSet`
-	       mkVarSet bndrs
+                            | (bndr, (rhs_fvs,_)) <- pairs])
+               `minusVarSet`
+               mkVarSet bndrs
 
     dest_lvl = destLevel env bind_fvs (all isFunction rhss) Nothing
     abs_vars = abstractVars dest_lvl env bind_fvs
 
 profitableFloat :: Level -> Level -> Bool
 profitableFloat ctxt_lvl dest_lvl
-  =  (dest_lvl `ltMajLvl` ctxt_lvl)	-- Escapes a value lambda
-  || isTopLvl dest_lvl    		-- Going all the way to top level
+  =  (dest_lvl `ltMajLvl` ctxt_lvl)     -- Escapes a value lambda
+  || isTopLvl dest_lvl                  -- Going all the way to top level
 
 ----------------------------------------------------
 -- Three help functions for the type-abstraction case
@@ -793,9 +787,9 @@ lvlFloatRhs abs_vars dest_lvl env rhs = do
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Deciding floatability}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
